{}
Unit Config;
interface
{}
type
 CharSet = Set of Char;
const
 LogName       = 'c:\Fido\Logs\rTrack.log';
 rTrackIniFile: String[10] = 'rTrack.ini';
{}
var
{ echos }
 UUEBase, InfoBase, RoboBase, MyMailBase, BadMailBase, DupeMailBase,
 LoopMailBase, RTRegBase, NetMailBase: String;

{ other }
 BSORoot, MainArea, uli, adr, TrackerName, TemplateDir, OutBoxes,
 ProtInbound, Inbound: String;
 PktCutSize: Longint;


{}
 procedure LoadIniParameters;
 function Trim(s: String; Ch: CharSet): String;


implementation

Uses rtapi;

{$IfNDef VirtualPascal}
procedure   SetLength(var s: string; NewLen: byte);
 begin
  s[0]:=Char(NewLen);
 end;
{$EndIf}

procedure   TrimEnd(var S: string; Ch: CharSet);
 begin
  if Length(s)<=0 then exit;
  while S[Length(s)] in ch do
  SetLength(s,Length(s)-1);
 end;

procedure   TrimStart(var S: string; Ch: CharSet);
 var
  p: byte;
 begin
  if Length(s)<=0 then exit;
  p:=1;
  while (s[p] in ch) and (p<=Length(s)) do Inc(p);
  if p>1 then
   begin
    move(s[p],s[1],length(s)+1-p);
    SetLength(s,Length(s)-pred(p));
   end;
 end;

function    Trim(s: String; Ch: CharSet): String;
 begin
  TrimStart(s,Ch);
  TrimEnd(s,Ch);
  Trim:=s;
 end;

procedure LoadIniParameters;
 var
  CurrentSection, CurrentValue, CurrentSValue: String;
  CurrentIValue: Integer;
 begin
  {  aka }
  CurrentSection:='akas';
  IniFindValue(True,rTrackIniFile,CurrentSection,CurrentValue);
  while not IniValueError do
   begin
    CurrentSValue:=IniReadString(rTrackIniFile,CurrentSection,CurrentValue);
    AddAka(CurrentValue,CurrentSValue);
    IniFindValue(False,rTrackIniFile,CurrentSection,CurrentValue);
   end;

  CurrentSection:='template macros';
  IniFindValue(True,rTrackIniFile,CurrentSection,CurrentValue);
  while not IniValueError do
   begin
    CurrentSValue:=IniReadString(rTrackIniFile,CurrentSection,CurrentValue);
    AddTemplateMacro(Trim(CurrentValue,['"']),Trim(CurrentSValue,['"']),False);
    IniFindValue(False,rTrackIniFile,CurrentSection,CurrentValue);
   end;

  CurrentSection:='domains';
  IniFindValue(True,rTrackIniFile,CurrentSection,CurrentValue);
  while not IniValueError do
   begin
    CurrentSValue:=IniReadString(rTrackIniFile,CurrentSection,CurrentValue);
    SetDomain(CurrentValue,CurrentSValue);
    IniFindValue(False,rTrackIniFile,CurrentSection,CurrentValue);
   end;

  CurrentSection:='parameters';
  SetPktParams(IniReadString(rTrackIniFile,CurrentSection,'pkt from'),
               IniReadString(rTrackIniFile,CurrentSection,'pkt to'),
               IniReadString(rTrackIniFile,CurrentSection,'pkt password'));
 { uncomment it if you do not have TZ }
{  SetUtc(IniReadString(rTrackIniFile,CurrentSection,'utc'));}
  MainArea:=IniReadString(rTrackIniFile,CurrentSection,'main area');
  TrackerName:=IniReadString(rTrackIniFile,CurrentSection,'tracker name');
  SetOrigin(IniReadString(rTrackIniFile,CurrentSection,'origin'));
  SetTearline(IniReadString(rTrackIniFile,CurrentSection,'tearline'));

  CurrentSection:='file names';
  CurrentSValue:=IniReadString(rTrackIniFile,CurrentSection,'route file');
  SetRouteFile(IniReadString(rTrackIniFile,CurrentSection,'route file'));
  SetDupeBase(IniReadString(rTrackIniFile,CurrentSection,'dupe base'),
              IniReadInteger(rTrackIniFile,CurrentSection,'max dupes'));

  CurrentSection:='folders';
  ProtInbound:=IniReadString(rTrackIniFile,CurrentSection,'unsecure inbound');
  Inbound:=IniReadString(rTrackIniFile,CurrentSection,'secure inbound');
  SetInboundDir(ProtInbound, Inbound);
  OutBoxes:=IniReadString(rTrackIniFile,CurrentSection,'file boxes');
  PktCutSize:=IniReadInteger(rTrackIniFile,CurrentSection,'box pkt cut');
  SetNodelistDir(IniReadString(rTrackIniFile,CurrentSection,'nodelist'));
  BSORoot:=IniReadString(rTrackIniFile,CurrentSection,'bso root');
  TemplateDir:=IniReadString(rTrackIniFile,CurrentSection,'templates');

  CurrentSection:='bases';
  NetMailBase:=IniReadString(rTrackIniFile,CurrentSection,'shared netmail');
  SetNetMail(NetMailBase);
  UUEBase:=IniReadString(rTrackIniFile,CurrentSection,'uue');
  InfoBase:=IniReadString(rTrackIniFile,CurrentSection,'info');
  RoboBase:=IniReadString(rTrackIniFile,CurrentSection,'robo');
  MyMailBase:=IniReadString(rTrackIniFile,CurrentSection,'raVen''s netmail');
  BadMailBase:=IniReadString(rTrackIniFile,CurrentSection,'bad netmail');
  DupeMailBase:=IniReadString(rTrackIniFile,CurrentSection,'dupe netmail');
  LoopMailBase:=IniReadString(rTrackIniFile,CurrentSection,'loop netmail');
  RTRegBase:=IniReadString(rTrackIniFile,CurrentSection,'rtrack reg base');

  CurrentSection:='additional ini';
  uli:=IniReadString(rTrackIniFile,CurrentSection,'uue limits');
  adr:=IniReadString(rTrackIniFile,CurrentSection,'address lists');

 end;

end.
{}
