{  }
{ Configuration file for rTrack program. v.2.4                }
{ Use RTlib by Dmitry Suhodoev, 2:550/428@fidonet             }
{ Copyright (C) 2000,01 by Alexey Tsvetnov, 2:463/816@fidonet }
{  }

Unit Config;


interface

const
     logname = 'd:\fido\log\rtrack.log';
     rTrackIniFile: String[10] = 'rtrack.ini';

var
   TrackerName, TemplateDir, Passwordlist, AttachLimits,
   NetMailBase, MyNetMailBase, BadNetMailBase, DupeNetMailBase,
   LoopNetMailBase, LBSOPath, FBoxesPath, BrakeBoxesPath: string;

   PktCutSize : integer;


procedure LoadIniParameters;


implementation

Uses rtapi;

procedure LoadIniParameters;
var
   CurrentSection, CurrentValue, CurrentSValue: String;

begin
  CurrentSection:='aka';
  IniFindValue(True,rTrackIniFile,CurrentSection,CurrentValue);
  while not IniValueError do
   begin
    CurrentSValue:=IniReadString(rTrackIniFile,CurrentSection,CurrentValue);
    AddAka(CurrentValue,CurrentSValue);
    IniFindValue(False,rTrackIniFile,CurrentSection,CurrentValue);
   end;

  CurrentSection:='parameters';
  TrackerName:=IniReadString(rTrackIniFile,CurrentSection,'trackername');
  SetUtc(IniReadString(rTrackIniFile,CurrentSection,'utc'));
  SetNodelistDir(IniReadString(rTrackIniFile,CurrentSection,'nodelist'));
  TemplateDir:=IniReadString(rTrackIniFile,CurrentSection,'templates');

  CurrentSection:='ini';
  SetRouteFile(IniReadString(rTrackIniFile,CurrentSection,'routefile'));
  passwordlist:=IniReadString(rTrackIniFile,CurrentSection,'passwordlist');

  CurrentSection:='folders';
  SetInboundDir(IniReadString(rTrackIniFile,CurrentSection,'inbound.secure'),
                IniReadString(rTrackIniFile,CurrentSection,'inbound.unsecure'));
  BrakeBoxesPath:=IniReadString(rTrackIniFile,CurrentSection,'out.BrakeBoxes');
  PktCutSize:=IniReadInteger(rTrackIniFile,CurrentSection,'out.pktsize');
  LBSOPath:=IniReadString(rTrackIniFile,CurrentSection,'out.LongBSO');
{  SetBSO(LBSOPath,IniReadInteger(rTrackIniFile,CurrentSection,'out.bso.mainzone'));}

  CurrentSection:='domain';
  IniFindValue(True,rTrackIniFile,CurrentSection,CurrentValue);
  while not IniValueError do
   begin
    CurrentSValue:=IniReadString(rTrackIniFile,CurrentSection,CurrentValue);
    SetDomain(CurrentSValue,CurrentValue);
    IniFindValue(False,rTrackIniFile,CurrentSection,CurrentValue);
   end;

  CurrentSection:='bases';
  SetDupeBase(IniReadString(rTrackIniFile,CurrentSection,'dupe.base'),
              IniReadInteger(rTrackIniFile,CurrentSection,'dupe.max'));
  NetMailBase:=IniReadString(rTrackIniFile,CurrentSection,'netmail.main');
  SetNetMail(NetMailBase);
  MyNetMailBase:=IniReadString(rTrackIniFile,CurrentSection,'netmail.my');
  BadNetMailBase:=IniReadString(rTrackIniFile,CurrentSection,'netmail.bad');
  DupeNetMailBase:=IniReadString(rTrackIniFile,CurrentSection,'netmail.dupe');
  LoopNetMailBase:=IniReadString(rTrackIniFile,CurrentSection,'netmail.loop');
 end;

end.
