{  }
{ rTrack program. v.2.4                                       }
{ Use RTlib by Dmitry Suhodoev, 2:550/428@fidonet             }
{ Copyright (C) 2000,01 by Alexey Tsvetnov, 2:463/816@fidonet }
{  }

Uses RTApi, Config;

var
    Param1 : string;

procedure Intro;
begin
    writeln;
    writeln(' Program by Alexey Tsvetnov, 2000,01 (2:463/816@fidonet)');
    writeln(' RTlib by Dmitry Suhodoev (2:550/428@fidonet)');
    writeln;
    writeln(' RTRACK <command>');
end;

procedure logoff;
begin
    writeln('   MAIL     - work with netmail');
    writeln('   NODELIST - compile nodelist');
    halt(1);
end;

 procedure UpStr(var Str : string);
 var
  i     : integer;
 begin
     for i := 1 to length(str) do Str[i] := UpCase(str[i]);
 end;

procedure Init;
begin
    InitRTLib(LogName,lNormal);
    LoadIniParameters;
end;

procedure Done;
begin
    DoneRTLib;
end;

procedure DeleteMsg;
begin
    rtapi.DeleteMsg;
    AddDupeRecord;
end;

procedure MoveMsg(Area,ToBase: String);
begin
    rtapi.MoveMsg(Area,ToBase);
    AddDupeRecord;
end;

procedure TossNetmail;

  function itRobotName: boolean;
  begin
      if itFromName('^itraX$',false) or itFromName('^UniMail$',false) or
         itFromName('fix$',false) or itFromName('track$',false) or
         itFromName('^Itrack\+?',false) or itFromName('^AllFix\+$',false) or
         itFromName('^FastEcho$',false) or itFromName('^AreaFix$',false) or
         itFromName('^ParToss$',false) or itFromName('mgr$',false) or
         itFromName('^checknl$',false) or itFromName('^FeKill$',false) or
         itFromName('^GEcho$',false) or itFromName('^ifcico$',false) or
         itFromName('^NEF$',false) or itFromName('server$',false)
            then itRobotName:=true
              else itRobotName:=false;
  end;

  { -- ⮡ 쬠     ⥫   }
  function CheckZone: boolean;
  begin
      if (FromZone>=1) and (FromZone<=6) and (ToZone>=1)
         and (ToZone<=6) then CheckZone := false
      else
      begin
          CheckZone := true;
          PrintStr('leftNET -> rightNET');
          MoveMsg('',BadNetMailBase);
      end;

  end;

  { -- 䨫㥬  䨪 ⮫쪮  2:463/816.*  2:463/463.* }
  function CheckMudak: boolean;
  begin
      if (ToAddr3d='2:463/463') and (FromAddr3d='2:463/816') then
      begin
          CheckMudak := true;
          PrintStr('Message for Mudak. Fuck to NETMAIL.BAD');
          MoveMsg('',BadNetMailBase);
      end
        else
           CheckMudak := false;
  end;

  { -- ஢塞    ( ᮢ) }
  function CheckNonAddr: boolean;
  begin
      if (ToAddr='2:0/0.0') or (FromAddr='2:0/0.0') then
      begin
          CheckNonAddr := true;
          PrintStr('Message without address. Move to NETMAIL.BAD');
          MoveMsg('',BadNetMailBase);
      end
        else
           CheckNonAddr := false;
  end;

  { --  ⥫   ? }
  function CheckToNode: boolean;
  begin
      if not ListedNode(ToAddr3D) and not itMyAddr(ToAddr3D) then
      begin
          CheckToNode := true;
          { ᫨ ,  頥 }
          if ListedNode(FromAddr3D) then
            Bounce(TemplateDir+'Badto.tpl',TrackerName,NetMailBase);
          PrintStr('a ⥫   .');
          MoveMsg('',BadNetMailBase);
      end
        else CheckToNode := false;
  end;

  { --  ࠢ⥫   e? }
  function CheckFromNode: boolean;
  begin
      if not ListedNode(FromAddr3D) and not itMyAddr(FromAddr3D) then
      begin
          CheckFromNode := true;
          PrintStr('a ࠢ⥫   .');
          MoveMsg('',BadNetMailBase);
      end
        else CheckFromNode := false;
  end;

  { --    ⠪ ? }
  function CheckToPoint: boolean;
  begin
      if not IniExistValue(PasswordList,'password', ToAddr) then
      begin
          CheckToPoint := true;
          Bounce(TemplateDir+'BadtoP.tpl',TrackerName,NetMailBase);
          PrintStr('  ⠪ .');
          MoveMsg('',BadNetMailBase);
      end
        else CheckToPoint := false;
  end;

  { --    ⠪ ? }
  function CheckFromPoint: boolean;
  begin
      if not IniExistValue(PasswordList,'password', FromAddr) then
      begin
          CheckFromPoint := true;
          PrintStr('  ⠪ .');
          MoveMsg('',BadNetMailBase);
      end
        else CheckFromPoint := false;
  end;

  { --   㯠? }
  function CheckLoop: boolean;
  begin
      if Loop(2) then
      begin
          CheckLoop := true;
          PrintStr('loop found');
          { 頥 ࠢ⥫ }
          Bounce(TemplateDir+'loop.tpl',TrackerName,NetMailBase);
          MoveMsg('',LoopNetMailBase)
      end
        else  CheckLoop := false;
  end;

  { --   ? }
  function CheckDupe: boolean;
  begin
      if DupeMsg then
      begin
          CheckDupe := true;
          PrintStr('dupe found');
          Bounce(TemplateDir+'dupe.tpl',TrackerName,NetMailBase);
          MoveMsg('',DupeNetMailBase);
      end
        else CheckDupe := false;
  end;

  { -- ஢ઠ  bark-style freq }
  function CheckBarkFreq: boolean;
  begin
      if FFrq then
      begin
          CheckBarkFreq := true;
          PrintStr('Bark-style freq found. Delete message.');
          Bounce(TemplateDir+'barkfreq.tpl',TrackerName,NetMailBase);
          DeleteMsg;
      end
        else  CheckBarkFreq := false;
  end;

  { -- ஢ઠ  Ping }
  function CheckPing: boolean;
  begin
      if ItToName('^Ping$',false) then
      begin
          CheckPing := true;
          PrintStr('ping found');
          Bounce(TemplateDir+'ping.tpl','Pong',NetMailBase);
          DeleteMsg;
      end
        else  CheckPing := false;
  end;

  { --   쬮  AreaFix? }
  function CheckAreaFix: boolean;
  begin
      if ItToName('^AreaFix$',false) then
      begin
          CheckAreaFix  := true;
          PrintStr('message to AreaFix');
          DosExec('d:\fido\areafix.cmd');
          CreateFlag('d:\fido\flags\rein.now');
      end
        else CheckAreaFix := false;
  end;

  { --   쬮  AllFix? }
  function CheckAllFix: boolean;
  begin
      if ItToName('^AllFix$',false) then
      begin
          CheckAllFix  := true;
          PrintStr('message to AllFix');
          DosExec('d:\fido\allfix.cmd');
          CreateFlag('d:\fido\flags\rein.now');
      end
        else CheckAllFix := false;
  end;

  { -- ⮡   ॢ 直 㢥ﬨ  ⥭ }
  procedure CheckCnf;
  begin
      if FRrq or FRrc then
      if itRobotName then PrintStr('some robot need for confirm')
       else
        if Bounce(TemplateDir+'Cfm.tpl',TrackerName,NetMailBase) then
        begin
            SetRrq(False,true);
            SetRrc(False,true);
        end;
  end;

  { -- 㢥  ࠢ }
  procedure CheckArq;
  begin
      if FArq then Bounce(TemplateDir+'arq.tpl',TrackerName,NetMailBase);
  end;

  { -- 㥬 쬮 }
  function PackToLink (dirflag, hldflag:boolean): boolean;
  var
     pass, rto : string;
  begin
  if not dirflag then
  begin
      if not hldflag then
      begin
          rto := RouteAddr(ToAddr);
          pass := IniReadString(PasswordList,'password',rto);
          PrintStr('Password ['+rto+'] : '+'['+pass+'] (route)');
          if BusyOutBound(rto,LBSOPath,otLongBSO) then
            PackToLink := PackToOutBound(rto,BrakeBoxesPath,pass,ofHold,otBrakeLongBox,PktCutSize,true,true,true)
            else PackToLink := PackToOutBound(rto,LBSOPath,pass,ofHold,otLongBSO,PktCutSize,true,false,true);
      end
       else
      begin
          pass := IniReadString(PasswordList,'password',ToAddr);
          PrintStr('Password ['+ToAddr+'] : '+'['+pass+'] (hld)');
          if BusyOutBound(ToAddr,LBSOPath,otLongBSO) then
            PackToLink := PackToOutBound('',BrakeBoxesPath,pass,ofHold,otBrakeLongBox,PktCutSize,true,true,false)
            else PackToLink := PackToOutBound('',LBSOPath,pass,ofHold,otLongBSO,PktCutSize,true,false,false)
      end;
  end
    else
    begin
       pass := IniReadString(PasswordList,'password',ToAddr);
       PrintStr('Password ['+ToAddr+'] : '+'['+pass+'] (dir)');
       if BusyOutBound(ToAddr,LBSOPath,otLongBSO) then
         PackToLink := PackToOutBound('',BrakeBoxesPath,pass,ofDirect,otBrakeLongBox,PktCutSize,true,true,false)
         else PackToLink := PackToOutBound('',LBSOPath,pass,ofDirect,otLongBSO,PktCutSize,true,false,false)
    end;
  end;

  { --  ᫨  䫠 Dir,  쬮    १ 㣮  䮫 }
  function CheckDirFlag: boolean;
  begin
      if FDir then
      begin
          CheckDirFlag := true;
          if PackTolink(true, false) then DeleteMsg;
      end
        else CheckDirFlag := false;
  end;

  { --  ᫨  䫠 Hld,  쬮    १ 㣮  䮫 }
  function CheckHldFlag: boolean;
  begin
      if FHld then
      begin
          CheckHldFlag := true;
          if PackTolink(false, true) then DeleteMsg;
      end
        else CheckHldFlag := false;
  end;

  { -- a   䠩-? }
  function CheckFileAttach: boolean;
  begin
      if FAtt then
      begin
          { -- ᫨   ,  ⠢塞   inbound }
          if ItMyAddr(ToAddr) then
          begin
              CheckFileAttach := true;
              PrintStr('file-attach from ['+FromAddr+'] to me');
              MoveMsg('',MyNetMailBase);
          end
            else
          if ItMyAddr(FromAddr) then
          begin
              CheckFileAttach := true;
              if FDir then
              begin
                  PrintStr('file-attach from me to ['+ToAddr+'] (dir)');
                  if MoveToOutBound('','',LBSOPath,ofDirect,otLongBSO,true,true,false) and
                  PackToLink(true, false) then DeleteMsg;
              end
                else
              if FHld then
              begin
                  PrintStr('file-attach from me to ['+ToAddr+'] (hld)');
                  if MoveToOutBound('','',LBSOPath,ofHold,otLongBSO,true,true,false) and
                  PackToLink(false, true) then DeleteMsg;
              end
                else
              begin
                  PrintStr('file-attach from me to ['+ToAddr+'] (route)');
                  if MoveToOutBound('','',LBSOPath,ofHold,otLongBSO,true,true,true) and
                  PackToLink(false, false) then DeleteMsg;
              end;
          end
            else
          begin
              CheckFileAttach := true;
              PrintStr('file-attach from ['+FromAddr+'] to ['+ToAddr+'] (route)');
              if MoveToOutBound('','',LBSOPath,ofHold,otLongBSO,true,true,true) and
              PackToLink(false, false) then DeleteMsg;
          end;
      end
       else CheckFileAttach := false;
  end;

begin
    PrintStr('msg #['+NToC(MsgNumber)+'] - ['+FromAddr+'] -> ['+ToAddr+']');

    { -- ᭮ ஢ન   ᥬ }
    if CheckMudak then exit;
    if CheckZone then exit;
    if CheckLoop then exit;
    if CheckDupe then exit;
    if CheckNonAddr then exit;
    if CheckFileAttach then exit;

    { -- ᫨ 쬮    㧥 }
    if not ItMyAddr(ToAddr3D) then
        if CheckToNode then exit;

    { -- ᫨ 쬮  c  㧫 }
    if not ItMyAddr(FromAddr3D) then
        if CheckFromNode then exit;

    { -- ᫨ 쬮  ⠬ }
    if ItMyAddr(ToAddr3D) and not ItMyAddr(ToAddr) then
        if CheckToPoint then exit;

    { -- ᫨ 쬮   ⮢ }
    if ItMyAddr(FromAddr3D) and not ItMyAddr(FromAddr) then
        if CheckFromPoint then exit;

    { -- ᫨ 쬮    }
    if ItMyAddr(ToAddr) then
    begin
        SetLoc(false,true);

        { -- ஢ઠ   ஡⮢  㦡 }
        if CheckAreaFix then exit;
        if CheckAllFix then exit;
        if CheckPing then exit;
        if CheckBarkFreq then exit;

        { -- 쬮 筮  }
        CheckCnf;
        SetRcv(true,true);
        SetSnt(false,true);
        SetTrs(False,true);
        SetK_s(False,true);
        SetHld(False,true);

        PrintStr('netmail for me');
        MoveMsg('',MyNetMailBase);
        exit;
    end;

    { -- ᫨ 쬮   }
    if ItMyAddr(FromAddr) then
    begin
       if CheckDirFlag then exit;
       if CheckHldFlag then exit;
    end;

    { -- ࠭⭮ 쬮 }
    CheckArq;
    SetRcv(false,true);
    SetSnt(false,true);
    SetTrs(false,true);
    SetDir(false,true);
    if PackTolink(false, false) then DeleteMsg;
end;

procedure ProcessNetmail;
begin
    Init;
    UnPackMail('*.pk?');
    if LoadMsg(True) then
    repeat
         if MsgLoaded then TossNetmail;
    until not LoadMsg(false)
      else PrintStr('nothing to scan...');

    PackBase(NetMailBase);
    Done;
end;

procedure ProcessNodelist;
var
    CurrentSection, CurrentValue : String;
    b : boolean;
begin
    Init;
    CurrentSection:='nodelist'; b:=false;
    IniFindValue(True,rTrackIniFile,CurrentSection,CurrentValue);
    while not IniValueError do
    begin
        CompileNodelist(CurrentValue,b);
        IniFindValue(False,rTrackIniFile,CurrentSection,CurrentValue);
        b:=true;
    end;
    Done;
end;

begin
    Intro;
    if ParamCount=0 then logoff
      else
    begin
        Param1 := ParamStr(1);
        UpStr(Param1);
        if Param1 = 'MAIL' then ProcessNetmail
          else
        if Param1 = 'NODELIST' then ProcessNodelist;
    end;
end.
